#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "RingBuff.h"			// CRingBuffg
#include "SendFileThread.h"		// CSendFileThreadg
#include "RecvFileThread.h"		// CRecvFileThreadg
#include "ChatMsgThread.h"		// CChatMsgThreadg

extern BOOL DestroySocket(SOCKET &fd);	// UDP\Pbgj邽 SimpleClietn.cppɂ

// Mx
#define		SEND_BPS	(1000000.0)	// Mx1Mbps

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pCRingBuffSend = new CRingBuff(SEND_BUFF_SIZE);	// MOobt@̍\z(TCP)
	m_pCRingBuffRecv = new CRingBuff(RECV_BUFF_SIZE);	// MOobt@̍\z(TCP)
	m_pCRingBuffSendUDP = new CRingBuff(SEND_BUFF_SIZE);// MOobt@̍\z(UDP)
	m_pCRingBuffRecvUDP = new CRingBuff(RECV_BUFF_SIZE);// MOobt@̍\z(UDP)

	m_dwPrevSentTime = 0;						// 񑗐M͂(TCP)
	m_dwSendInterval = 0;						// 
	m_dwPrevSentTimeUDP = 0;					// 񑗐M͂(UDP)
	m_dwSendIntervalUDP = 0;					// 

	m_pCSendFileThread = NULL;					// t@CM{Xbh
	m_pCRecvFileThread = NULL;					// t@CM{Xbh

	m_fdUDP = INVALID_SOCKET;					// f[^MUDPUDP\Pbg
	m_bTarnsMethod = 0;							// 0:TCP 1:UDP CTRL_TRANS_METHOD_RESMŊm
	// ̏o(|[gTCP̐ڑŎgp̂Ȃ̂UDPgpɕύX)
	m_iPeerAddrLen = (socklen_t)m_pConInfo->ai_addrlen;
	memcpy(&m_PeerAddr, m_pConInfo->ai_addr, m_iPeerAddrLen);

	// `bgbZ[WɎg悤ɏ
	m_pCChatMsgThread = new CChatMsgThread(this);
	m_pCChatMsgThread->Begin();
}


//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	if (m_pCChatMsgThread != NULL)		// ̃NXjƂɃ`bgbZ[WXbhj
	{
		m_pCChatMsgThread->End();
		m_pCChatMsgThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCChatMsgThread)
	if (m_pCSendFileThread != NULL)		// Ă~߂(fKvł傤)
	{
		m_pCSendFileThread->End();
		m_pCSendFileThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCSendFileThread)
	if (m_pCRecvFileThread != NULL)		// Ă~߂(fKvł傤)
	{
		m_pCRecvFileThread->End();
		m_pCRecvFileThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCRecvFileThread)

	SAFE_DELETE(m_pCRingBuffSend)		// MOobt@̔j(TCP)
	SAFE_DELETE(m_pCRingBuffRecv)		// MOobt@̔j(TCP)
	SAFE_DELETE(m_pCRingBuffSendUDP)	// MOobt@̔j(UDP)
	SAFE_DELETE(m_pCRingBuffRecvUDP)	// MOobt@̔j(UDP)
	DestroySocket(m_fdUDP);				// UDP\Pbg̔j
}

//----------------------------------------------
// function
//    @\Lq֐(DoSend, DoRecv̓eLq)
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	fd_set      wfds, rfds;
	struct timeval   tv;
	int			iSendSize = 0;				// Mf[^TCY
	DWORD		dwNow;						// M`FbNo邽

	while (!m_fStopFlag)
	{
		// svȃXbhj
		// `bgbZ[WXbhG[ȂI
		if (KillZombei() == TRUE)
		{
			fRet = FALSE;
 			break;
		}
		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;				// 10msec
		FD_ZERO(&rfds);
		FD_ZERO(&wfds);
		// Mf[^pfd_set͏ɃZbg
		FD_SET(m_pConInfo->fdClient, &rfds);
		// M\Mf[^ƂM\pfd_setɃZbg
		// `FbN̂߂Ɍݎ擾
		timeBeginPeriod(1);					// ^C}[̍ŏx1msecɂ
		dwNow = timeGetTime();
		timeEndPeriod(1);					// ^C}[̍ŏx߂
		// Mf[^邩Oobt@𒲂ׂ(TCP)
		iSendSize = m_pCRingBuffSend->GetReadableSize();
		// TCP̑M\Mf[^邩
		if ((iSendSize > 0) && (CanSendNow(dwNow, 0) == TRUE))
			FD_SET(m_pConInfo->fdClient, &wfds);

		// f[^]@UDP̎AUDP̑M̂߂̏
		if (m_bTarnsMethod == 1)
		{
			// Mf[^pfd_set͏ɃZbg
			FD_SET(m_fdUDP, &rfds);
			// Mf[^邩Oobt@𒲂ׂ(UDP)
			iSendSize = m_pCRingBuffSendUDP->GetReadableSize();
			// UDP̑M\Mf[^邩
			if ((iSendSize > 0) && (CanSendNow(dwNow, 1) == TRUE))
				FD_SET(m_fdUDP, &wfds);
		}

		select(FD_SETSIZE, &rfds, &wfds, NULL, &tv);	// ^CAEg܂SleepƓ

		// MTCP
		if((fRet = RecvTCPData(&rfds)) == FALSE)
			break;
		// MUDP
		if ((fRet = RecvUDPData(&rfds)) == FALSE)
			break;

		// MOobt@Ɋi[Ăf[^̉͂s
		// ̃pPbgi[Ă\̂ŁAFD_ISSEŤʂƂ͖֌W
		// ͂s悤ɂ
		// TCPMf[^̉
		if (AnalyzeDataRecv(0) == -1)					// Ԓl-1̎G[
		{
			DispErrorMsg("Err:Packet format TCP");
			fRet = FALSE;
			break;
		}
		// UDPMf[^̉
		if (AnalyzeDataRecv(1) == -1)					// Ԓl-1̎G[
		{
			DispErrorMsg("Err:Packet format UDP");
			fRet = FALSE;
			break;
		}

		// M(TCP)
		if ((fRet = SendTCPData(&wfds, dwNow)) == FALSE)
			break;
		// M(UDP)
		if ((fRet = SendUDPData(&wfds, dwNow)) == FALSE)
			break;
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		TCP̎M
//		MOobt@Ɋi[
// parameter
//		fd_set *rfds	[in]
// return
//		TRUE/FALSE:ؒf/G[
//----------------------------------------------
BOOL CSendRecvThread::RecvTCPData(fd_set *rfds)
{
	BOOL	fRet = TRUE;
	char	szRecvBuffer[RCVBUFSIZE];				// Mf[^ꎞIɊi[
	int		iRecvSize;

	if (FD_ISSET(m_pConInfo->fdClient, rfds))		// Mf[^recv{
	{
		// MOobt@ɋ󂫂Ύ擾
		// ŎMȂ΁AFD_ISSETŎMf[^肪Zbĝ
		// Ɏ擾邱Ƃł
		iRecvSize = min(m_pCRingBuffRecv->GetWriteableSize(), RCVBUFSIZE);
		if (iRecvSize > 0)
		{
			if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, iRecvSize, 0)) <= 0)
			{
				if (iRecvSize == 0)
					DispErrorMsg("Disconnected recv");
				else
					DispErrorMsg("Err:recv");
				fRet = FALSE;
			}
			else
			{
				// 擾f[^ɎMOobt@ɏ
				// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
				m_pCRingBuffRecv->Write((LPBYTE)szRecvBuffer, iRecvSize);
			}
		}
	}
	return(fRet);
}

//----------------------------------------------
// function
//		UDP̎M
//		MOobt@Ɋi[
// parameter
//		fd_set *rfds	[in]
// return
//		TRUE
//----------------------------------------------
BOOL CSendRecvThread::RecvUDPData(fd_set *rfds)
{
	BOOL	fRet = TRUE;
	char	szRecvBuffer[RCVBUFSIZE];			// Mf[^ꎞIɊi[
	int		iRecvSize;
	sockaddr_storage	PeerAddr;				// MAhXi[GA
	socklen_t	iPeerLen;

	if (FD_ISSET(m_fdUDP, rfds))				// Mf[^recvfrom{
	{
		// UDPł̓pPbgTCY菬TCYŎMƎc͔j
		// ŎMȂ΁ǍŎMs
		if (m_pCRingBuffRecvUDP->GetWriteableSize() > RCVBUFSIZE)
		{
			iPeerLen = sizeof(PeerAddr);	// MAhXi[\̂̃TCY
			if ((iRecvSize = recvfrom(m_fdUDP, szRecvBuffer, RCVBUFSIZE, 0, (sockaddr *)&PeerAddr, &iPeerLen)) < 0)
			{
				DispErrorMsg("Err:recvfrom");
				fRet = FALSE;
			}
			else
			{
				char		szPeerAddr[NI_MAXHOST];		// AhX,|[gԍ
				char		szServiceNo[NI_MAXSERV];	// getnameinfoŎ擾

				// M̕\
				getnameinfo((sockaddr *)&PeerAddr, iPeerLen, szPeerAddr, NI_MAXHOST,
					szServiceNo, NI_MAXSERV, NI_NUMERICHOST | NI_NUMERICSERV);
				fprintf(stderr, "recvfrom socket:%d Addr:%s Port:%s\n:",
					m_fdUDP, szPeerAddr, szServiceNo);
				// 擾f[^ɎMOobt@ɏ
				// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
				m_pCRingBuffRecvUDP->Write((LPBYTE)szRecvBuffer, iRecvSize);
			}
		}
	}
	return(TRUE);
}

//----------------------------------------------
// function
//		TCP̑M
//		MOobt@̃f[^𑗐M
// parameter
//		fd_set	*wfds	[in]
//		DWORD	dwNow	[in]ݎ
// return
//		TRUE/FALSE:ؒf/G[
//----------------------------------------------
BOOL CSendRecvThread::SendTCPData(fd_set *wfds, DWORD dwNow)
{
	BOOL	fRet = TRUE;
	char	*pcData = NULL;						// Mf[^
	int		iSendSize = 0;						// Mf[^TCY

	if (FD_ISSET(m_pConInfo->fdClient, wfds))	// M\Ȃsend{
	{
		// Mf[^̎擾(PATH_MTU菬Ȃ悤Ɏ擾)
		iSendSize = GetSendData(&pcData, 0);
		if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
		{
			DispErrorMsg("Err:send\n");
			fRet = FALSE;
		}
		SAFE_FREE(pcData)
		// MƎ񑗐M܂ł̎ԂZbg
		m_dwPrevSentTime = dwNow;
		m_dwSendInterval = CalcNextSendInterval(iSendSize);
	}
	SAFE_FREE(pcData)
	return(fRet);
}

//----------------------------------------------
// function
//		UDP̑M
//		MOobt@̃f[^𑗐M
// parameter
//		DWORD	dwNow	[in]ݎ
//		fd_set	*wfds	[in]
// return
//		TRUE
//----------------------------------------------
BOOL CSendRecvThread::SendUDPData(fd_set *wfds, DWORD dwNow)
{
	BOOL	fRet = TRUE;
	char	*pcData = NULL;				// Mf[^
	int		iSendSize = 0;				// Mf[^TCY

	if ((m_bTarnsMethod == 1) && (FD_ISSET(m_fdUDP, wfds)))
	{
		// Mf[^̎擾(PATH_MTU菬Ȃ悤Ɏ擾)
		iSendSize = GetSendData(&pcData, 1);
		if (sendto(m_fdUDP, pcData, iSendSize, 0, (sockaddr *)&m_PeerAddr, m_iPeerAddrLen) != iSendSize)
		{
			DispErrorMsg("Err:sendto");
			fRet = FALSE;
		}
		SAFE_FREE(pcData)
		// MƎ񑗐M܂ł̎ԂZbg
		m_dwPrevSentTimeUDP = dwNow;
		m_dwSendIntervalUDP = CalcNextSendInterval(iSendSize);
	}
	SAFE_FREE(pcData)
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ(TCP/UDP)
// parameter
//		char	*pcData		[in]Mf[^
//		int		iSize		[in]f[^
//		BOOL	fForceTCP	[in]KTCP(Rg[)
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize, BOOL fForceTCP)
{
	BOOL	fRet = FALSE;
	CRingBuff	*pCRingBuff = ((fForceTCP == FALSE) && (m_bTarnsMethod == 1)) ? m_pCRingBuffSendUDP : m_pCRingBuffSend;

	// MOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = pCRingBuff->Write((LPBYTE)pcData, iSize);

	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾(TCP/UDP)
// parameter
//		char	**ppcData	[in/out]Mf[^
//		int		iTcpUdp		[in]0:TCP 1:UDP
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData, int iTcpUdp)
{
	int		iSize = 0;
	CRingBuff	*pCRingBuff = (iTcpUdp == 1) ? m_pCRingBuffSendUDP : m_pCRingBuffSend;

	// Mf[^邩Oobt@̃f[^TCY𒲂ׂ
	if ((iSize = pCRingBuff->GetReadableSize()) > 0)
	{
		// MTCYPATH_MTU菬Ă(1024+ʃwb_Ȃv)
		iSize = min(iSize, SENDBUFSIZE);
		*ppcData = (char *)calloc(iSize, sizeof(char));
		iSize = pCRingBuff->Read((LPBYTE)*ppcData, iSize);
	}
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̉
//		MOobt@Ɋi[Ăf[^𒲂ׂ
// parameter
//		int		iTcpUdp		[in]0:TCP 1:UDP
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::AnalyzeDataRecv(int iTcpUdp)
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	CRingBuff	*pCRingBuff = (iTcpUdp == 1) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;
	// f[^TCY𒲂ׂ
	int			iSize = pCRingBuff->GetReadableSize();

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;
	// wb_؂ǂݍ݂
	pCRingBuff->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	// wb_̉
	if (memcmp(Header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
	{
		iRet = -1;							// ʎqႤ̂ŃG[
		goto L_END;
	}
	wCmd = ntohs(Header.wCommand);
	Locate(1, 7, 1);
	fprintf(stderr, "CMD:%d\n", wCmd);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			iRet = RecvMessagePacket(&Header, iTcpUdp);
			break;
		case CMD_SEND_FILE_START_RES:		// t@CMR}h/̏
		case CMD_SEND_FILE_END_RES:
		case CMD_SEND_FILE_ABORT_RES:
			iRet = RecvFileSendResPacket(&Header, iTcpUdp);
			break;
		case CMD_RECV_FILE_SIZE_RES:		// t@CMR}h/̏
		case CMD_RECV_FILE_ABORT_RES:
		case CMD_RECV_FILE_ING:
		case CMD_RECV_FILE_END_REQ:
			iRet = RecvFileRecvResPacket(&Header, iTcpUdp);
			break;
		case CTRL_TRANS_METHOD_RES:			// f[^M@
			if (iTcpUdp == 0)				// TCP̂
				iRet = RecvTransMethodResPacket(&Header);
			else
				iRet = -1;
			break;
		default:							// mȂR}hȂ̂ŃG[
			iRet = -1;
			break;
	}
L_END:
	return(iRet);
}


//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		HeaderRec	*pHeader	[in]ǂ݂wb_
//		int			iTcpUdp		[in]0:TCP 1:UDP
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::RecvMessagePacket(HeaderRec *pHeader, int iTcpUdp)
{
	int			iRet = 0;
	int			iDataSize, iSize, iPacketSize;
	LPBYTE		pbPacket = NULL;
	CRingBuff	*pCRingBuff = (iTcpUdp == 1) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;

	iDataSize = ntohs(pHeader->wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);

	iSize = pCRingBuff->GetReadableSize();
	if (iSize < iPacketSize)
		goto L_END;
	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	pCRingBuff->ReadWithoutUpdateHeadPoint(pbPacket, iPacketSize);
	if (m_pCChatMsgThread != NULL)
	{
		// `bgbZ[WXbhɓnǂݍ񂾂Ƃɂ
		if (m_pCChatMsgThread->m_pCRingBuffCmd->Write(pbPacket, iPacketSize) == TRUE)
		{
			pCRingBuff->UpdateHeadPoint(iPacketSize);
			iRet = 1;
		}
	}
	else
	{
		// `bgbZ[WXbhȂ΃G[ؒf
		pCRingBuff->UpdateHeadPoint(iPacketSize);
		iRet = -1;
	}
	SAFE_FREE(pbPacket);
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}h/(SC)t@CMXbhɓn
// parameter
//		HeaderRec	*pHeader	[in]ǂ݂wb_
//		int			iTcpUdp		[in]0:TCP 1:UDP
// return
//		0:pPbgĂȂ, t@CMt
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::RecvFileSendResPacket(HeaderRec *pHeader, int iTcpUdp)
{
	int			iRet = 0;
	int			iDataSize, iSize, iPacketSize;
	LPBYTE		pbPacket = NULL;
	CRingBuff	*pCRingBuff = (iTcpUdp == 1) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;

	iDataSize = ntohs(pHeader->wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);

	iSize = pCRingBuff->GetReadableSize();
	if (iSize < iPacketSize)
		goto L_END;
	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	pCRingBuff->ReadWithoutUpdateHeadPoint(pbPacket, iPacketSize);
	// t@CMXbhɓnǂݍ񂾂Ƃɂ
	if (m_pCSendFileThread != NULL)
	{
		if (m_pCSendFileThread->m_pCRingBuffCmd->Write(pbPacket, iPacketSize) == TRUE)
		{
			pCRingBuff->UpdateHeadPoint(iPacketSize);
			iRet = 1;
		}
	}
	else
		pCRingBuff->UpdateHeadPoint(iPacketSize); // t@CMXbhȂƂ͓ǂݍ񂾂Ƃɂ

	SAFE_FREE(pbPacket);
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}h/(SC)t@CMXbhɓn
// parameter
//		HeaderRec	*pHeader	[in]ǂ݂wb_
//		int			iTcpUdp		[in]0:TCP 1:UDP
// return
//		0:pPbgĂȂ, t@CMt
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::RecvFileRecvResPacket(HeaderRec *pHeader, int iTcpUdp)
{
	int			iRet = 0;
	int			iDataSize, iSize, iPacketSize;
	LPBYTE		pbPacket = NULL;
	CRingBuff	*pCRingBuff = (iTcpUdp == 1) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;

	iDataSize = ntohs(pHeader->wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);

	iSize = pCRingBuff->GetReadableSize();
	if (iSize < iPacketSize)
		goto L_END;
	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	pCRingBuff->ReadWithoutUpdateHeadPoint(pbPacket, iPacketSize);
	// t@CMXbhɓnǂݍ񂾂Ƃɂ
	if (m_pCRecvFileThread != NULL)
	{
		if (m_pCRecvFileThread->m_pCRingBuffCmd->Write(pbPacket, iPacketSize) == TRUE)
		{
			pCRingBuff->UpdateHeadPoint(iPacketSize);
			iRet = 1;
		}
	}
	else		// t@CMXbhȂ̂ŃG[
	{
		iRet = -1;
		pCRingBuff->UpdateHeadPoint(iPacketSize); // t@CMXbhȂƂ͓ǂݍ񂾂Ƃɂ
	}
	SAFE_FREE(pbPacket);
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		f[^]@̎M
// parameter
//		HeaderRec *pHeader	[in]ǂ݂wb_
// return
//		0:pPbgĂȂ, t@CMt
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::RecvTransMethodResPacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	int			iDataSize, iSize, iPacketSize;
	LPBYTE		pbPacket = NULL;
	TransMethodReqRec *pTransMethod;

	iDataSize = ntohs(pHeader->wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);

	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iPacketSize)
		goto L_END;
	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffRecv->Read(pbPacket, iPacketSize);
	pTransMethod = (TransMethodReqRec *)pbPacket;
 	m_bTarnsMethod = pTransMethod->TansMethodInfo.bMethod;
	Locate(12, 7, 1);
	fprintf(stderr, "TransMethod:%s", (m_bTarnsMethod == 1) ? "UDP" : "TCP");
	// UDPʐMpɑsockaddr 
	if (m_bTarnsMethod == 1)		// UDP
		m_bTarnsMethod = MakePeerUDPSockaddr(ntohs(pTransMethod->TansMethodInfo.wUDPSrcPort));

	if(m_bTarnsMethod == 0)							// TCP
	{
		DestroySocket(m_fdUDP);						// UDPŗvĂj
	}
	iRet = 1;

L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		UDPʐMpɑsockaddr 
//		m_PeerAddr̃|[gԍύX
// parameter
//		WORD wPeerPort	[in]|[g
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::MakePeerUDPSockaddr(WORD wPeerPort)
{
	BOOL		fRet = FALSE;
	char        szAddr[NI_MAXHOST], szPort[NI_MAXSERV] = {0};
	addrinfo	hints, *pres = NULL;

	// AhX̎o
	getnameinfo((sockaddr *)&m_PeerAddr, m_iPeerAddrLen, szAddr, sizeof(szAddr), NULL, 0, NI_NUMERICHOST);
	DISABLE_C4996
	sprintf(szPort, "%d", wPeerPort);	// |[gԍ
	ENABLE_C4996
	memset(&hints, 0, sizeof(hints));
	// AhXƃ|[gԍw
	if (getaddrinfo(szAddr, szPort, &hints, &pres) == 0)
	{
		memcpy(&m_PeerAddr, pres->ai_addr, pres->ai_addrlen);
		m_iPeerAddrLen = (socklen_t)pres->ai_addrlen;
		freeaddrinfo(pres);
		fRet = TRUE;
	}
	return(fRet);
}

//----------------------------------------------
// function
//		̑M܂ł̊Ԋu(msec)߂
// parameter
//		Ȃ
// return
//		msec
//----------------------------------------------
DWORD CSendRecvThread::CalcNextSendInterval(int iSentSize)
{
	DWORD	dwInterval = 0;
	double	dbBytePerSec = SEND_BPS / 8.0;
	double	dbCountPerSec;

	if (iSentSize == 0)
		goto L_END;
	dbCountPerSec = dbBytePerSec / (double)iSentSize;
	dwInterval = DWORD(1000.0 / dbCountPerSec);

L_END:
	return(dwInterval);
}


//----------------------------------------------
// function
//		M\
// parameter
//		DWORD dwNow		[in]ݎ
//		int iTcpUdp		[in]0:TCP 1:UDP
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::CanSendNow(DWORD dwNow, int iTcpUdp)
{
	BOOL	fRet = FALSE;
	DWORD	dwPrevSentTime = (iTcpUdp == 1) ? m_dwPrevSentTimeUDP : m_dwPrevSentTime;
	DWORD	dwSendInterval = (iTcpUdp == 1) ? m_dwSendIntervalUDP : m_dwSendInterval;

	if (GetdwInterval(dwNow, dwPrevSentTime) >= dwSendInterval)
		fRet = TRUE;

	return(fRet);
}

//----------------------------------------------
// function
//		bZ[WpPbg̑M
// parameter
//		char	*pcData		[in]UTF-8f[^(NULL^[~l[gȂ)
//		int		iSize		[in]f[^TCY
// retun
//		Ȃ
//----------------------------------------------
BOOL CSendRecvThread::SendMessagePacket(char *pcData, int iSize)
{
	BOOL		fRet = FALSE;

	if (m_pCChatMsgThread == NULL)
		goto L_END;

	m_pCChatMsgThread->SendMessagePacket(pcData, iSize);
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̎{
// parameter
//		LPSTR	pszFileName	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SendFile(LPSTR pszFileName)
{
	BOOL		fRet = FALSE;

	// t@CMXbhLȎ(M)͑MJnȂ
	if (m_pCSendFileThread != NULL)
	{
		fprintf(stderr, "t@CM@t@CM܂ő҂Ă\n");
		goto L_END;
	}
	m_pCSendFileThread = new CSendFileThread(this, pszFileName);
	m_pCSendFileThread->Begin();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒f
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SendFileAbort()
{
	BOOL		fRet = FALSE;

	if (m_pCSendFileThread == NULL)
		goto L_END;

	m_pCSendFileThread->SendFileAbort();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̎{
// parameter
//		LPSTR	pszFileName	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::RecvFile(LPSTR pszFileName)
{
	BOOL		fRet = FALSE;

	// t@CMXbhLȎ(M)͎MJnȂ
	if (m_pCRecvFileThread != NULL)
	{
		fprintf(stderr, "t@CM@t@CM܂ő҂Ă\n");
		goto L_END;
	}
	m_pCRecvFileThread = new CRecvFileThread(this, pszFileName);
	m_pCRecvFileThread->Begin();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒f
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::RecvFileAbort()
{
	BOOL		fRet = FALSE;

	if (m_pCRecvFileThread == NULL)
		goto L_END;

	m_pCRecvFileThread->RecvFileAbort();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		f[^M@̃lSVG[V
//		UDPw莞UDP\Pbg쐬
//		m͉M
// parameter
//		BYTE	bMethod		[in]0:TCP 1:UDP
//		WORD	wUDPSrcPort	[in]UDPM|[gԍ/0
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SendTransMethodPacket(BYTE bMethod, WORD wUDPSrcPort)
{
	TransMethodReqRec	*pTransMethod = NULL;
	int			iPacketSize = sizeof(TransMethodReqRec);		// pPbgTCY
	BOOL		fRet = FALSE;
	addrinfo	hints, *pres = NULL;
	char		szPort[NI_MAXSERV] = { 0 }, szAddr[NI_MAXHOST] = {0};
	sockaddr_storage Addr;
	socklen_t	iAddrLen;
	int			on;

	if (m_bTarnsMethod == bMethod)			// ύXȂƂ͉Ȃ
	{
		fRet = TRUE;
		goto L_END;
	}
// UDP̎UDP\Pbg
	if (bMethod == 1)
	{
		DestroySocket(m_fdUDP);
		// UDP\Pbg쐬
		if ((m_fdUDP = socket(m_PeerAddr.ss_family, SOCK_DGRAM, 0)) == INVALID_SOCKET)
			goto L_END;
		// bind
		memset(&hints, 0, sizeof(hints));
		hints.ai_family = m_PeerAddr.ss_family;
		hints.ai_socktype = SOCK_DGRAM;			// UDP
		// ׂẴC^[tF[XŎM
		hints.ai_flags = AI_PASSIVE;
		DISABLE_C4996
		sprintf(szPort, "%d", wUDPSrcPort);		// |[gԍ
		ENABLE_C4996
		if (getaddrinfo(NULL, szPort, &hints, &pres) != 0)
			goto L_END;
#ifdef IPV6_V6ONLY
		// IPv6\PbgIPv4ˉeAhXgpȂ悤ɐݒ
		if (m_PeerAddr.ss_family == AF_INET6)
		{
			on = 1;
			if (setsockopt(m_fdUDP, IPPROTO_IPV6, IPV6_V6ONLY, (char *)&on, sizeof(on)) < 0)
			{
				DispErrorMsg("Err:setsockopt");
				goto L_END;
			}
		}
#endif
		if (bind(m_fdUDP, pres->ai_addr, (int)pres->ai_addrlen) == SOCKET_ERROR)
		{
			DispErrorMsg("Err:bind");
			goto L_END;
		}
		// wUDPSrcPort0̂Ƃ́AIȃ|[g蓖Ă̂Œׂ
		iAddrLen = sizeof(Addr);
		getsockname(m_fdUDP, (sockaddr *)&Addr, &iAddrLen);
		getnameinfo((sockaddr *)&Addr, iAddrLen, szAddr, sizeof(szAddr), szPort, sizeof(szPort), NI_NUMERICHOST | NI_NUMERICSERV);
	}

	pTransMethod = (TransMethodReqRec *)calloc(iPacketSize, sizeof(BYTE));	// pPbgŜ̃GAm
	memcpy(pTransMethod->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pTransMethod->header.wCommand = htons(CTRL_TRANS_METHOD_REQ);
	pTransMethod->header.wDataLen = htons(sizeof(TransMethodInfoRec));
	pTransMethod->TansMethodInfo.bMethod = bMethod;
	pTransMethod->TansMethodInfo.wUDPSrcPort = htons((WORD)atol(szPort));	// TCP͈̎ӖȂ̂0Zbg
	// Rg[͋ITCPőM
	fRet = SetSendData((char *)pTransMethod, iPacketSize, TRUE);

	SAFE_FREE(pTransMethod)
L_END:
	if(pres != NULL)
		freeaddrinfo(pres);
	if (fRet == FALSE)
		DestroySocket(m_fdUDP);
	return(fRet);
}

//----------------------------------------------
// function
//		̃XbhXbh(vIG[)̎j
//		jƂ͐ؒf̂߂ CSendRecvThreadI
// parameter
//		Ȃ
// return
//		TRUE:vIG[Ŕj/FALSE:vIG[Ȃ
//----------------------------------------------
BOOL CSendRecvThread::KillZombei()
{
	BOOL	fRet = FALSE;

	// t@CMXbh
	if (m_pCSendFileThread != NULL)
	{
		if (m_pCSendFileThread->IsZombie() == TRUE)
		{
			m_pCSendFileThread->End();
			m_pCSendFileThread->WaitForEnd();
			SAFE_DELETE(m_pCSendFileThread)
		}
	}
	// t@CMXbh
	if (m_pCRecvFileThread != NULL)
	{
		if (m_pCRecvFileThread->IsZombie() == TRUE)
		{
			m_pCRecvFileThread->End();
			m_pCRecvFileThread->WaitForEnd();
			SAFE_DELETE(m_pCRecvFileThread)
		}
	}
	// `bgbZ[WXbh
	if (m_pCChatMsgThread != NULL)
	{
		if (m_pCChatMsgThread->IsZombie() == TRUE)
		{
			m_pCChatMsgThread->End();
			m_pCChatMsgThread->WaitForEnd();
			SAFE_DELETE(m_pCChatMsgThread)
			fRet = TRUE;
		}
	}
	return(fRet);
}
